<?php

/**
 * i-Educar - Sistema de gesto escolar
 *
 * Copyright (C) 2006  Prefeitura Municipal de Itaja
 *                     <ctima@itajai.sc.gov.br>
 *
 * Este programa  software livre; voc pode redistribu-lo e/ou modific-lo
 * sob os termos da Licena Pblica Geral GNU conforme publicada pela Free
 * Software Foundation; tanto a verso 2 da Licena, como (a seu critrio)
 * qualquer verso posterior.
 *
 * Este programa  distribudo na expectativa de que seja til, porm, SEM
 * NENHUMA GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU
 * ADEQUAO A UMA FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral
 * do GNU para mais detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto
 * com este programa; se no, escreva para a Free Software Foundation, Inc., no
 * endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     Avaliacao
 * @subpackage  Modules
 * @since       Arquivo disponvel desde a verso 1.1.0
 * @version     $Id$
 */

require_once 'Avaliacao/Model/Etapa.php';

/**
 * Avaliacao_Model_ParecerDescritivoAbstract abstract class.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     Avaliacao
 * @subpackage  Modules
 * @since       Classe disponvel desde a verso 1.1.0
 * @version     @@package_version@@
 */
abstract class Avaliacao_Model_ParecerDescritivoAbstract extends Avaliacao_Model_Etapa
{
  protected $_data = array(
    'parecerDescritivoAluno' => NULL,
    'parecer'                => NULL
  );

  protected $_references = array(
    'parecerDescritivoAluno' => array(
      'value' => NULL,
      'class' => 'Avaliacao_Model_ParecerDescritivoAluno',
      'file'  => 'Avaliacao/Model/ParecerDescritivoAluno.php'
    )
  );

  /**
   * @see CoreExt_Entity_Validatable#getDefaultValidatorCollection()
   */
  public function getDefaultValidatorCollection()
  {
    $etapa  = $this->getValidator('etapa');
    $etapas = $etapa->getOption('choices') + array('An');

    $etapa->setOptions(array('choices' => $etapas));

    return array(
      'etapa'   => $etapa,
      'parecer' => new CoreExt_Validate_String()
    );
  }

  /**
   * Implementa mtodo mgico __toString().
   * @link http://br.php.net/__toString
   * @return string
   */
  public function __toString()
  {
    return (string)$this->parecer;
  }
}
