<?php

/**
 * i-Educar - Sistema de gesto escolar
 *
 * Copyright (C) 2006  Prefeitura Municipal de Itaja
 *                     <ctima@itajai.sc.gov.br>
 *
 * Este programa  software livre; voc pode redistribu-lo e/ou modific-lo
 * sob os termos da Licena Pblica Geral GNU conforme publicada pela Free
 * Software Foundation; tanto a verso 2 da Licena, como (a seu critrio)
 * qualquer verso posterior.
 *
 * Este programa  distribudo na expectativa de que seja til, porm, SEM
 * NENHUMA GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU
 * ADEQUAO A UMA FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral
 * do GNU para mais detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto
 * com este programa; se no, escreva para a Free Software Foundation, Inc., no
 * endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     FormulaMedia
 * @subpackage  UnitTests
 * @since       Arquivo disponvel desde a verso 1.1.0
 * @version     $Id$
 */

require_once 'FormulaMedia/Validate/Formula.php';

/**
 * ValidateFormulaTest class.
 *
 * @author      Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category    i-Educar
 * @license     @@license@@
 * @package     FormulaMedia
 * @subpackage  UnitTests
 * @since       Classe disponvel desde a verso 1.1.0
 * @version     @@package_version@@
 */
class ValidateFormulaTest extends UnitBaseTest
{
  public function testFormulaValida()
  {
    $formula = 'Se / Et';
    $validator = new FormulaMedia_Validate_Formula();
    $this->assertTrue($validator->isValid($formula));
  }

  public function testFormulaValidaUsandoAliasDeMultiplicacao()
  {
    $formula = 'Se x 0.99 / Et';
    $validator = new FormulaMedia_Validate_Formula();
    $this->assertTrue($validator->isValid($formula));
  }

  public function testFormulaValidaComNumericos()
  {
    $formula = 'Se * 0.5 / Et';
    $validator = new FormulaMedia_Validate_Formula();
    $this->assertTrue($validator->isValid($formula));
  }

  /**
   * @expectedException Exception
   */
  public function testFormulaInvalidaQuandoUtilizaTokenNaoPermitido()
  {
    $formula = 'Rc * 0.4 + Se * 0.6';
    $validator = new FormulaMedia_Validate_Formula();
    $this->assertTrue($validator->isValid($formula));
  }

  public function testFormulaValidaUsandoParenteses()
  {
    $formula = '(Rc * 0.4) + (Se * 0.6)';
    $validator = new FormulaMedia_Validate_Formula(array('excludeToken' => NULL));
    $this->assertTrue($validator->isValid($formula));
  }

  /**
   * @expectedException FormulaMedia_Validate_Exception
   */
  public function testFormulaInvalidaPorErroDeSintaxe()
  {
    $formula = '(Rc * 0.4) + (Se * 0.6) ()';
    $validator = new FormulaMedia_Validate_Formula(array('excludeToken' => NULL));
    $this->assertTrue($validator->isValid($formula));
  }
}