<?php

/**
 * i-Educar - Sistema de gesto escolar
 *
 * Copyright (C) 2006  Prefeitura Municipal de Itaja
 *                     <ctima@itajai.sc.gov.br>
 *
 * Este programa  software livre; voc pode redistribu-lo e/ou modific-lo
 * sob os termos da Licena Pblica Geral GNU conforme publicada pela Free
 * Software Foundation; tanto a verso 2 da Licena, como (a seu critrio)
 * qualquer verso posterior.
 *
 * Este programa  distribudo na expectativa de que seja til, porm, SEM
 * NENHUMA GARANTIA; nem mesmo a garantia implcita de COMERCIABILIDADE OU
 * ADEQUAO A UMA FINALIDADE ESPECFICA. Consulte a Licena Pblica Geral
 * do GNU para mais detalhes.
 *
 * Voc deve ter recebido uma cpia da Licena Pblica Geral do GNU junto
 * com este programa; se no, escreva para a Free Software Foundation, Inc., no
 * endereo 59 Temple Street, Suite 330, Boston, MA 02111-1307 USA.
 *
 * @author    Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category  i-Educar
 * @license   @@license@@
 * @package   Core_View
 * @since     Arquivo disponvel desde a verso 1.1.0
 * @version   $Id$
 */

require_once 'Core/_stub/View.php';
require_once 'Core/Controller/_stub/Page/Abstract.php';

/**
 * Core_ViewTest class.
 *
 * @author    Eriksen Costa Paixo <eriksen.paixao_bs@cobra.com.br>
 * @category  i-Educar
 * @license   @@license@@
 * @package   Core_View
 * @since     Classe disponvel desde a verso 1.1.0
 * @version   @@package_version@@
 */
class Core_ViewTest extends UnitBaseTest
{
  protected $_pageController = NULL;
  protected $_view = NULL;

  public function __construct()
  {
    $this->_pageController = new Core_Controller_Page_AbstractStub();
    $this->_pageController->setOptions(array('processoAp' => 1, 'titulo' => 'foo'));
  }

  protected function setUp()
  {
    $this->_view = new Core_ViewStub($this->_pageController);
  }

  public function testTituloConfiguradoComValorDeConfiguracaoGlobal()
  {
    global $coreExt;
    $instituicao = $coreExt['Config']->app->template->vars->instituicao;

    $this->_view->MakeAll();
    $this->assertEquals($instituicao . ' | foo', $this->_view->getTitulo());
  }

  public function testProcessoApConfiguradoPeloValorDePageController()
  {
    $this->_view->MakeAll();
    $this->assertEquals(1, $this->_view->getProcessoAp());
  }
}